' Name des Autopilots
AIName[CONTROLS_COUNTDOKU] = "Count-Dokus Autopilot"

' Intelligenz des Autopilots
' pRobot ist der Roboter
'	Ihr drft nicht auf die Felder von pRobot zugreifen!
'	pRobot wird lediglich verwendet als Parameter fr die Funktionen
'	GetV1, GetV2, AccelerateRobot und AccelerateRobotTo
' pDists ein Array mit den Distanzen der Sensoren
'	Das Array ist SENSORS_VIS_CNT gross, resp 2 * SENSORS_PER_SIDE + 1
'	Index 0 ist der Sensor, der ganz nach rechts zeigt
'	Index SENSORS_PER_SIDE zeigt geradeaus
'	Index SENSORS_VIS_CNT - 1 zeigt nach links
'	Die Distanz ist in Einheiten angeben (1 Einheit = 1 Tile)
Function AutoPilotRobot_COUNTDOKU(pRobot:TRobot, pDists:Float[])
	Local biggestDist:Float = 0, biggestDistIndex:Int = 0
	For Local j:Int = -SENSORS_PER_SIDE To SENSORS_PER_SIDE
		Local i:Int = j + SENSORS_PER_SIDE
		
		If (pDists[i] > biggestDist) Then
			biggestDist = pDists[i]
			biggestDistIndex = j
		EndIf
	Next

	Local anglePerSensor:Float = (180 / SENSORS_VIS_CNT) ;
	Local bestAngle:Float = anglePerSensor * biggestDistIndex;

	Local leftWheel:Float, rightWheel:Float
	leftWheel = MAX_VEL;
	rightWheel = MAX_VEL;
	
	If (bestAngle < 0) Then
		leftWheel = leftWheel + 0.025 * Sgn(bestAngle)
	ElseIf (bestAngle > 0) Then
		rightWheel = rightWheel - 0.025 * Sgn(bestAngle)
	EndIf
	
	AccelerateRobotTo(pRobot, leftWheel, rightWheel)
End Function

